@echo off
setlocal enabledelayedexpansion

set "devpath=..\Alisha's DevKit (v122-87)\Keal's Frontend\"

set projectname=%~1
set projectpath=%~dp1

if "%projectname%"=="" exit /b

call :projectname %projectname%
echo %projectname%

call :killprocess "%projectname%"

if not exist "!devpath!" (
	mkdir "!devpath!"
)

rem :: if not exist "!devpath!%~n0" (
rem :: 	copy "%~dpnx0" "!devpath!%~nx0"
rem :: )

set "devpathx=!devpath!!projectname!\"

if not exist "!devpathx!" (
	mkdir "!devpathx!"
)

if not exist "!devpathx!%projectname%.rc" (
	(
		echo FB_PROGRAM_ICON ICON "!devpathx!%projectname%.ico"
	) >> "!devpathx!%projectname%.rc"
)

if not exist "!devpathx!%projectname%.ico" (
	copy "!devpath!blank disk.ico" "!devpathx!%projectname%.ico"
)

call :debugger

set options_compiler="..\Alisha's DevKit (v122-87)\FreeBASIC\fbc32.exe"
set options_exe=-x "%projectname%.exe"
set options_build=-asm intel
set options_gui=-s gui "!devpathx!%projectname%.rc"
set options_debug=-exx -g -gen gas
set options_lib=

set log="!devpathx!%projectname% ( Compile Log ).html"
set templog="!devpathx!%projectname% ( Debris ).temp"

type NUL > !log!

call :docheader
(
	echo ^<h1^>"%projectname%" Compiler Log ^(in HTML^)^</h1^>
	echo ^<h3^>%DATE% %TIME%^</h3^>

) >> !log!

set evenodd=0

if exist "%projectpath%%projectname%.exe" (
	echo ^<h3^>Now Pruning: "%projectpath%%projectname%.exe"^</h3^> >> %log%
	del /F "%projectpath%%projectname%.exe"
)

echo ^<h3^>Now Compiling: "%projectpath%%projectname%.bas" using %options_compiler%^</h3^> >> %log%

echo ^<h3^>%options_compiler% %options_exe% "%projectpath%%projectname%.bas" %options_build% %options_gui% %options_debug% %options_lib% > %templog%^</h3^> >> %log%

call :options

echo ^<table^> >> %log%
%options_compiler% %options_exe% "%projectpath%%projectname%.bas" %options_build% %options_gui% %options_debug% %options_lib% > %templog%
	
set /A "ErrCount=0"
set /A "ErrLine=0"

for /f "usebackq delims=" %%A in (%templog%) do (
	
	echo ^<tr^>^<td^>^<pre class="e!ErrLine!"^>%%A^</pre^>^</td^>^</tr^> >> %log%
	set /a "ErrCount+=1"
	set /a "ErrLine=1-!ErrLine!"
)

del /f %templog%

echo ^</table^> >> %log%

if %ErrCount% EQU 0 (
	if exist %projectpath%%projectname%.exe" (
		echo ^<h3^>Successfully Compiled: %projectpath%%projectname%.exe"^</h3^> >> %log%
	) else (
		echo ^<h3 style="color: red;"^>Failed Compiling: %projectpath%%projectname%.exe"^</h3^> >> %log%
	)
) else (
	echo ^<h3 style="color: red;"^>Errors Compiling: %projectpath%%projectname%.exe"^</h3^> >> %log%
)

echo ^</body^>^</html^> >> %log%

exit /b 0

:debugger

	set debugger="!devpathx!%projectname% ( SARG's FB Debugger ).cmd"

	type NUL > %debugger%

	(
		echo echo SARG's FB Debugger
		echo "%~dp0..\..\Alisha's DevKit (v122-87)\fbdebug_WDS_LNX\Windows 32bit\fbdebugger_new.exe" "%projectpath%%projectname%.exe"
	) >> %debugger%

	exit /B
	
:options
(
	echo ^<h3^>Using Following Options:^</h3^>
	echo ^<ul^>
	echo ^<li^>Binary:^<ul^>^<li^>%options_exe%^</li^>^</ul^>^</li^>
	echo ^<li^>Source:^<ul^>^<li^>%projectpath%%projectname%.bas"^</li^>^</ul^>^</li^>
	echo ^<li^>Build:^<ul^>^<li^>%options_build%^</li^>^</ul^>^</li^>
	echo ^<li^>Gui:^<ul^>^<li^>%options_gui%^</li^>^</ul^>^</li^>
	echo ^<li^>Debug:^<ul^>^<li^>%options_debug%^</li^>^</ul^>^</li^>
	echo ^<li^>Lib:^<ul^>^<li^>%options_lib%^</li^>^</ul^>^</li^>
	echo ^</ul^>
) >> !log!
	
	exit /B
	
:stylesheet

(
	echo ^<style^>
 	echo 	table, td, td {
	echo 		background-color: rgba^( 196, 196, 196, 0.5 ^);
	echo  		color: Black;
	echo  	}
	echo  	td.centerx {
	echo  		text-align: center;
	echo  	}
	echo.
	echo  	pre {
	echo  	    white-space: pre-wrap;       /^* Since CSS 2.1 ^*/
	echo  	    white-space: -moz-pre-wrap;  /^* Mozilla, since 1999 ^*/
	echo  	    white-space: -pre-wrap;      /^* Opera 4-6 ^*/
	echo  	    white-space: -o-pre-wrap;    /^* Opera 7 ^*/
	echo  	    word-wrap: break-word;       /^* Internet Explorer 5.5^+ ^*/
	echo  	}
	echo.
	echo 	.e1 {
	echo  		background-color: rgba ^( 240, 240, 240, 0.4 ^);
	echo 	}
	echo.
	echo 	.e0 {
	echo  		background-color: rgba ^( 196, 196, 196, 0.3 ^);
	echo 	}
	echo ^</style^>
) >> !log!
	
	exit /B
	

:docheader

(
	echo ^<^^!DOCTYPE html^>
	echo ^<html lang="en-us"^>
	echo ^<head^>
	echo ^<meta charset="UTF-8"^>
	echo ^<meta name="Author" content="trkeal@gmail.com http://puzzlum.net/"^>
	echo ^<meta name="GENERATOR" content="Mozilla/4.75 [en]C-CCK-MCD {U S WEST.net}	^(Win98; U^) [Netscape]"^>
	echo ^<meta name="Classification" content="project compilation"^>
	echo ^<meta name="Description" content="%projectname% ^( Keal's Batch Compiler log ^)"^>
	echo ^<meta name="KeyWords" content="%projectname%"^>
) >> !log!

(
	echo ^<title^>"%projectname%" Compiler Log ^(in HTML^)^</title^>
	echo ^<link
	echo 	rel="icon"
	echo 	type="image/png"
	echo 	href="/pzlm-assets/gfx/puzzlum.png" ^>
) >> !log!

call :stylesheet

(
	echo ^</head^>
	echo ^<body^>
	rem :: ^<table class="wide"^>^<tbody^>
) >> !log!

	exit /B
	
:projectname

	if "!projectname:~-4!"==".cmd" (
		set "projectname=!projectname:~0,-4!"
	)
	
	if "!projectname:~-13!"==" ( Frontend )" (
		set "projectname=!projectname:~0,-13!"
	)
	
	exit /B

:killprocess
	
	for /f "usebackq skip=2 tokens=1 delims=," %%T in (`tasklist /fi "IMAGENAME eq %~1.exe" /fo csv`) do (
		echo Killing Process: "%~1.exe"
		TASKKILL /F /IM "%~1.exe" /T 2>nul
	)
	exit /B
	
	
:realpath

	set "realpath=%~dpnx0"
	exit /B